<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  
  <xsl:output method="xml" encoding="iso-8859-1" indent="yes"/>

  <xsl:template match="classification_atomique">
    <xsl:copy>
      <xsl:call-template name="categorie">
        <xsl:with-param name="type_categorie">gaz rare</xsl:with-param>
      </xsl:call-template>
      <xsl:call-template name="categorie">
        <xsl:with-param name="type_categorie">mtal alcalin</xsl:with-param>
      </xsl:call-template>
      <xsl:call-template name="categorie">
        <xsl:with-param name="type_categorie">mtal alcalino-terreux</xsl:with-param>
      </xsl:call-template>
      <xsl:call-template name="categorie">
        <xsl:with-param name="type_categorie">non mtal</xsl:with-param>
      </xsl:call-template>
    </xsl:copy>
  </xsl:template>

  <xsl:template name="categorie">
    <xsl:param name="type_categorie"/>
    <xsl:element name="famille">
      <xsl:attribute name="type">
        <xsl:value-of select="$type_categorie"/>
      </xsl:attribute>
      <xsl:for-each select="atome[type=$type_categorie]">
        <xsl:call-template name="atome"/>
      </xsl:for-each> 
    </xsl:element>
  </xsl:template>

  <xsl:template name="atome">
    <xsl:copy>
      <xsl:copy-of select="nom"/>
      <xsl:copy-of select="symbole"/>
      <xsl:copy-of select="numero"/>
      <xsl:copy-of select="masse"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>