<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:msxsl="urn:schemas-microsoft-com:xslt"
extension-element-prefixes="msxsl"
version="1.0">
<!-- Feuille XSLT de transcodage -->
<xsl:output method="xml" indent="yes" encoding="ISO-8859-1"/>

<xsl:param name="transcodage">
<!-- Table de transcodage (ce pourrait tre un fichier externe)-->
<item avant="%E9" apres=""/>
<item avant="%2C" apres="."/>
<item avant="+" apres=" "/>
</xsl:param>

<!-- Reproduire le document  l'identique --> 
<xsl:template match="@* | *"> 
<xsl:copy> 
<xsl:apply-templates select="@* | * | text()"/> 
</xsl:copy>
</xsl:template> 

<!-- ...Sauf les textes, que l'on va transcoder -->
<xsl:template match="text()">
<xsl:apply-templates select="msxsl:node-set($transcodage)/*[position()=1]" mode="transcode">
<xsl:with-param name="avanttranscodage" select="." />
</xsl:apply-templates>
</xsl:template>

<xsl:template match="*" mode="transcode">
<!-- template de transcodage. Navigue sur la table de transcodage -->
<xsl:param name="avanttranscodage"/>

<xsl:variable name="aprestranscodage">
<xsl:call-template name="substitue">
<xsl:with-param name="atranscoder" select="$avanttranscodage"/>
</xsl:call-template>
</xsl:variable>

<xsl:choose>
<xsl:when test="following-sibling::*">
<!-- Tant qu'il y a d'autres lments dans la table de transcodage, relancer le mme template sur ces lments -->
<xsl:apply-templates select="following-sibling::*[position()=1]" mode="transcode">
<xsl:with-param name="avanttranscodage" select="$aprestranscodage"/>
</xsl:apply-templates>
</xsl:when>
<xsl:otherwise>
<!-- Sinon, renvoyer le rsultat du transcodage -->
<xsl:value-of select="$aprestranscodage"/>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="substitue">
<!-- template rentrant de susbstitution -->
<xsl:param name="atranscoder"/>

<xsl:choose>
<xsl:when test="contains($atranscoder,@avant)">
<!-- Si il reste qqch  transcoder, le transcoder -->
<xsl:variable name="resultat">
<xsl:value-of select="concat(substring-before($atranscoder,@avant),@apres, substring-after($atranscoder,@avant))"/>
</xsl:variable>
<xsl:call-template name="substitue">
<!-- Relancer le mme template sur le rsultat pour continuer le transcodage, s'il y a lieu -->
<xsl:with-param name="atranscoder" select="$resultat"/>
</xsl:call-template>
</xsl:when>
<xsl:otherwise>
<!-- Si plus rien  transcoder, ne rien faire et renvoyer le paramtre " transcoder" -->
<xsl:value-of select="$atranscoder"/>
</xsl:otherwise>
</xsl:choose>

</xsl:template>

</xsl:stylesheet>


